Name:           shmpps
Version:        1.03
Release:        3%{?dist}
Summary:        Shared Memory driver for PPS time signals

Group:          System Environment/Daemons
License:        Public Domain and MIT
URL:            http://time.qnan.org/
Source0:        http://time.qnan.org/%{name}.tar
Source1:        shmpps.service
Source2:        shmpps.sysconfig

Requires:       ntp
BuildRequires:  systemd-units
Requires(post): systemd-sysv
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

%description
Shared memory (SHM) driver to allow high-resolution pulse-per-second
(PPS) time sources to be used with a Network Time Protocol (NTP) server
without a PPS-enabled kernel.  The PPS pin of the time source must be
connected to the declared signal pin on a serial or parallel port.

See /etc/sysconfig/shmpps for configuration.

%prep
%setup -q -n %{name}
sed -i \
    -e 's/#undef  *DOPARALLEL/#define DOPARALLEL/' \
    shm_splc2.c

%build
make CFLAGS="%{optflags}" LDFLAGS=""

%install
install -p -m755 -D shm_splc2 %{buildroot}%{_sbindir}/shm_splc2
install -p -m644 -D %{SOURCE1} %{buildroot}%{_unitdir}/shmpps.service
install -p -m644 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/shmpps

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable shmpps.service > /dev/null 2>&1 || :
    /bin/systemctl stop shmpps.service > /dev/null 2>&1 || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart shmpps.service >/dev/null 2>&1 || :
fi

%triggerun -- shmpps < 1.03-3
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply shmpps
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save shmpps >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del shmpps >/dev/null 2>&1 || :
/bin/systemctl try-restart shmpps.service >/dev/null 2>&1 || :

%files
%{_sbindir}/shm_splc2
%{_unitdir}/shmpps.service
%config(noreplace) %{_sysconfdir}/sysconfig/shmpps

%changelog
* Thu Sep 15 2011 Tom Callaway <spot@fedoraproject.org> - 1.03-3
- convert to systemd

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.03-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Nov 22 2008 Chris Adams <linux@cmadams.net> 1.03-1
- initial package

